/* Last updated on 13 Jun 2005, at 19:29.  */
/* modified version of newfiles.cmd written by Alex Cantatore        */

call SysSleep 1            /* wait 1 second */

parse arg filename year

dot = pos('.', filename)                              /* a.s.  5 Jan 1999 */
filen = substr(filename,1,dot - 1)                    /* a.s.  5 Jan 1999 */
filename = filename                                   /* a.s. 29 Nov 2002 */

/* costanti globali */
nl = "0a"x
nn = "0d"x
nlnn = "0d0a"x
root = "hobbes.nmsu.edu/pub"

flen = chars(filename)
data = charin(filename, 1, flen)
call charout filename

mese.01 = "Jan"
mese.02 = "Feb"
mese.03 = "Mar"
mese.04 = "Apr"
mese.05 = "Maj"
mese.06 = "Giu"
mese.07 = "Jul"
mese.08 = "Ago"
mese.09 = "Sep"
mese.10 = "Oct"
mese.11 = "Nov"
mese.12 = "Dec"

/* flag varie */
flag       = 0
brokenline = 0
nlines     = 0
wrote      = 0
htmistart  = ""
dir        = ""
prevdir    = ""
last       = 0
link       = 2000
incflag    = 0

day   = '01'
month = '01'

/* name of ouput file */
htmioutfile = filen'.htm'                         /* a.s. 29 Nov 2002 */
hdate       = day'-'mese.month'-'year
ldate       = year'/'month'/'day
slh  = lastpos('\', filename)                     /* a.s. 2 Feb 2003 */
filn = substr(filename,slh+1,10)                  /* a.s. 2 Feb 2003 */
select
 when filn = 'hobbesFROM' then                    /* a.s. 2 Feb 2003 */
      DO
        say nl" Extraction from  "filename" from date ===> "hdate
      END
 when filn = 'hobbes'year then                    /* a.s. 2 Feb 2003 */
      DO
        say nl" Extraction from "filename" of files with date ===> "year
      END
 otherwise                                        /* a.s. 2 Feb 2003 */
 end                                              /* a.s. 2 Feb 2003 */
say ' OUTPUT file = 'htmioutfile                  /* a.s. 5 Jan 1999 */

htmoutdata = "<p>"nl

htmlstart= "<HTML><HEAD><TITLE>HOBBES - New Files</TITLE>"||,
  "</HEAD><body bgcolor=#ffffff><P><table width=90%>"||,
  "<tr><td><BR><DD><center>"||,
  "<BR><h1><font color=blue>New files from HOBBES from "hdate"</font></h1>"nl ||,
  "</center></td></tr></table><center>"||,
  "<table width=80%><tr><td>"nl ||,
  "This is the list of files added from specified "nl ||,
  "date, in the archive of HOBBES ; <B>total of "

htmlframedata = " file</B>.<br>"nl ||,
                "<P><UL></center>"
compDate = year"/"right(month, 2, 0)"/"right(day, 2, 0)
today    = date("S")
curmonth = substr(today, 5, 2)
curyear  = left(today, 4)

call charout , "0d0a"x
call showStatusBar

do while data \= ""
   parse var data temp (nl) data
   remain = length(data)
   level = ((flen - remain) * 70) % flen
   if level > last then do
      call charout , ""
      last = level
      end /* do */
   temp = strip(temp, , nn)
   temp = strip(temp)

   parse var temp fname size fdate des

 if fname \= './ ' then do
   fpub = 'pub'
   if left(fname, 2) = "./" then do
      dir = strip(substr(fname, 2), "T", ":")
      if left(dir, 9) = "/incoming" then
         incflag = 1         /* next files    */
      else                   /* are in "incoming" dir */
         incflag = 0
         fpub = ''
         flag = 1            /* directory change */
   end /* do */
   if fdate >= compDate &,
      left(fname, 7) \= "00index" &,
      left(fname, 8) \= "00global" &,
      left(fname, 7) \= "00files" &,
      size \= "DIR" &,
      \(incflag & (translate(right(fname, 4)) == ".TXT")) then do
      if flag then do
         htmoutdata = htmoutdata""htmistart"<CENTER><H2><a name="""link ||,
                       """>"dir"</a></H2></CENTER>"nl ||,
                       "<TABLE BORDER=1 CELLPADDING=3 WIDTH=90%>"nl||,
                       "<TR><TH>file</TH>" ||,
                       "<TH>dimens.</TH><TH>data</TH>" ||,
                       "<TH>descrizione</TH></TR>"nl

         htmistart = "</TABLE><P>"nl
         link = link + 1
         prevdir = dir
      end /* do */
      parse var fdate  yy "/" mm "/" dd
      if datatype(yy) = 'NUM' & datatype(size) = 'NUM' then do
         if ldate < fdate then
            ldate = fdate
        ffdate = strip(dd, "L", "0")"/"mese.mm"/"yy
        htmldes = htmtrans(des)
        select
           when length(size) < 4 then
              ffsize = size" Byte"
           when length(size) > 3 & length(size) < 7 then
              ffsize = left(size, length(size) - 3)"," ||right(size, 3)" KB"
           otherwise do
            size = (size + 444) % 1000 ffsize = left(size, length(size) - 3)"," ||right(size, 3)" MB"
           end
        end /* select */
      end /* do 'NUM'*/
      if incflag then do
         if fname = "README.POLICY" | fname = "README.TEMPLATE" then
            nop
         else
            htmoutdata = htmoutdata ||,
               "<TR VALIGN=TOP><TD><A HREF=""ftp://"root""dir"/"fname""">"||,
               fname"</A> (<A HREF=""ftp://"root"/"fname ||,
               """>definitivo</A>)" ||,
               "</TD><TD ALIGN=RIGHT>"ffsize ||,
               "</TD><TD ALIGN=RIGHT>"ffdate ||,
               "</TD><TD>" htmldes"</TD></TR>"nl
         end /* do */
      else
            htmoutdata = htmoutdata ||,
               "<TR VALIGN=TOP><TD><A HREF=""ftp://"root""dir"/"fname""">"||,
               fname"</A></TD><TD ALIGN=RIGHT>"ffsize ||,
               "</TD><TD ALIGN=RIGHT>"ffdate ||,
               "</TD><TD>" htmldes"</TD></TR>"nl
            flag = 0
            wrote = wrote + 1
      end  /* do */
 end /* do if fname \= './ ' */
   nlines = nlines + 1
end

htmoutdata = htmoutdata"</TABLE>"nl"</td></tr></table><p>"nl ||,
                       "<center>"nl"<BR><center>"nl ||,
                       "<BR><h3><font color=blue>" ||,
                       "END of list of HOBBES files - most recent file: "nl||,
                       ldate"</BR></center>"nl||,
                       "</BR></center>"nl ||,
                       "</BODY></HTML>"

htmlframedata = htmlframedata"</UL><P>"nl
call charout htmioutfile, htmlstart""wrote""htmlframedata""htmoutdata, 1
call charout htmioutfile
call charout , "0d0a0d0a0d0a"x
say " Process Completed!"nlnn" "filename": " nlines "Linee  " ||,
    "Total of files:" wrote nlnn||" last date: "ldate
RC = SysFileDelete(filename)
exit


htmtrans: procedure
parse arg string
   string = strip(string)
   htmlout = ""
   if string = "" then
      return " - "
   do i = 1 to length(string)
      ch = substr(string, i, 1)
      select
         when ch = "<" then
            htmlout = htmlout"&lt;"
         when ch = ">" then
            htmlout = htmlout"&gt;"
         when ch = "&" then
            htmlout = htmlout"&amp;"
         otherwise
            htmlout = htmlout""ch
      end
   end
return htmlout


showStatusbar: procedure
   say " 0%                                50%                               100%"
   say " |                                  |                                  |"
   call charout, " "
   call charout, ""
return

